#include	<avr/io.h>
#include	<avr/interrupt.h>

//   ͷƮ  ƾ û- 
volatile unsigned int	f1=0, f2=0;

// ܺ  ȣ
#define	TR_A	PB0
#define	TR_B	PB1
#define	TR_C	PB2
#define	TR_D	PB3

#define	L1	PE0
#define	L2	PE1

// ܺ Է½ȣ
#define	S1	PE4
#define	S2	PE5

#define	SW1	PE6
#define	SW2	PE7

//  --  ̺
#define	MOTOR_STOP	((PORTB & 0xF0) | 1<<TR_A | 1<<TR_B)
#define	MOTOR_UP	((PORTB & 0xF0) | 1<<TR_B | 1<<TR_D)
#define	MOTOR_DOWN	((PORTB & 0xF0) | 1<<TR_A | 1<<TR_C)

// 1, 2  ǥ  ̺
#define	L1_ON	(( PORTE & ~(1<<L1 | 1<<L2)) | 1<<L1)
#define	L2_ON	(( PORTE & ~(1<<L1 | 1<<L2)) | 1<<L2)

// ͷƮ ǥ ̺
#define	SW1_INTERRUPT	INT6_vect
#define	SW2_INTERRUPT	INT7_vect

ISR(SW2_INTERRUPT)
{	f2 = 1;	}

ISR(SW1_INTERRUPT)
{	f1 = 1;	}

//////////////////////////////////////////////////////////////
int	main(void)
{	//  
	enum	{ INIT, FLOOR1, UP, FLOOR2, DOWN }	state=INIT;

	// Ʈ  ȣ  ⼳
	DDRB |= 1<<TR_A | 1<<TR_B | 1<<TR_C | 1<<TR_D;
	
	// LED  ǥ  ȣ
	DDRE |= 1<<L1 | 1<<L2;

	// S1, S2, SW1, SW2  Ǯ 
	PORTE |= 1<<S1 | 1<<S2 | 1<<SW1 | 1<<SW2;	
	
	// PE7, PE6 ܺ ͷƮ Ȱȭ
	EIMSK |= 1<<SW1 | 1<<SW2;	

	sei();		// start global interrupt

	while(1){
		switch(state){
		case INIT:
			PORTB = MOTOR_DOWN;
			if( !(PINE & 1<<S1) ){
				PORTB = MOTOR_STOP;
				PORTE = L1_ON;
				f1 = 0;
				state = FLOOR1;
			}
			break;
			
		case FLOOR1:
			if( f2==1 && f1==0){
				PORTB = MOTOR_UP;
				state = UP;
			}else
				f1 = 0;
			break;
			
		case UP:
			if( !(PINE & 1<<S2) ){
				PORTB = MOTOR_STOP;
				PORTE = L2_ON;
				f2 = 0;
				state = FLOOR2;
			}
			break;
				
		case FLOOR2:
			if( f1==1 && f2==0){
				PORTB = MOTOR_DOWN;
				state = DOWN;
			}else
				f2 = 0;
			break;
			
		case DOWN:
			if( !(PINE & 1<<S1) ){
				PORTB = MOTOR_STOP;
				PORTE = L1_ON;
				f1 = 0;
				state = FLOOR1;
			}
			break;
		}
	}
	return 0;
}
